#!/usr/bin/perl
# calculate the normal distribution for the collected frequency data
# - the formula is taken from wikipedia
#   - the order in which the terms in the formula are calculated is important to
#     avoid getting a zero answer

my(@lines, $line, $balls, $freq, %ballsFreq, $totalFreq, $totalBalls,
   $average, $diffFromAverage, $totalDiffFromAverageWeightedSquared, 
   $variance, $pi, $e, $t, $texpr, $probability, $chance);

$pi = 3.141592653589793;
$e  = 2.718281828459045;

chomp(@lines = <>);

foreach $line (@lines) {
    ($balls, $freq) = split(/\D+/, $line);
    $ballsFreq{$balls} += $freq;
    $totalFreq  += $freq;
    $totalBalls += $balls * $freq;
}

$average = $totalBalls / $totalFreq;

foreach $balls (keys %ballsFreq) {
   $freq  = $ballsFreq{$balls};
   $diffFromAverage = ($balls - $average);
   $totalDiffFromAverageWeightedSquared += 
                                   $diffFromAverage * $diffFromAverage * $freq; 
}

$variance = $totalDiffFromAverageWeightedSquared / $totalFreq;
$stddev = sqrt $variance;

#print "avg: $average, variance: $variance, std-dev: $stddev\n"; 

$t = 1 / $variance;
$texpr = 1 / sqrt (2 * $variance * $pi);

#print "t $t, texpr $texpr\n";

foreach $balls (5 .. 90) {
    $diffFromAverage = ($balls - $average);
    $eexpr = -1 * $diffFromAverage * $diffFromAverage / 2 * $t;
    $probability = $texpr * $e ** $eexpr;
    $chance = $probability * 100;

    #print "$balls $chance $diffsquared $eexpr\n";
    print "$balls $chance\n"
}
